{$I-}
{$G+}
Unit USEDRAW; (* Piotr Pawlus *)

Interface

 Procedure Cls;
 Function GetMode: Byte;

 Procedure GoToXY (X,Y: Byte);
 Function WhereX: Byte;
 Function WhereY: Byte;
 Procedure HideKursor;
 Procedure ShowKursor;

 Procedure PutChar (X,Y: Byte;Znak: Char;Kolor,Tlo: Byte);
 Procedure PutString (X,Y: Byte;Napis: String;Kolor,Tlo: Byte);

 Procedure FillScreen (Znak: Char;Kolor,Tlo: Byte);
 Procedure FillWindow (X,Y,X1,Y1: Byte;Znak: Char;Kolor,Tlo: Byte);

 Procedure DrawWindow (X,Y,X1,Y1,Kolor,Tlo: Byte;Cien: Boolean;Var Linia);

 Procedure ButtonString (X,Y: Byte;Napis: String;Kolor,Tlo: Byte);
 Procedure LineDown (Napis: String;Kolor,Tlo,Spec: Byte);

 Function LoadSCR (Plik: String;P: Pointer;Ile: Word): Byte;
 Function SaveSCR (Plik: String;P: Pointer;Ile: Word): Byte;

 Procedure GetScreen (P: Pointer);
 Procedure PutScreen (P: Pointer);

 Procedure GetWindow (P: Pointer;X,Y,X1,Y1: Byte);
 Procedure PutWindow (P: Pointer);
 Procedure xPutWindow (X,Y: Byte;P: Pointer);

 Function GetFields (P: Pointer): Word;
 Procedure PutFields (P: Pointer);

 Procedure PutColor (X,Y,Kolor: Byte);
 Procedure PutBackGround (X,Y,Tlo: Byte);
 Procedure FillColor (X,Y,X1,Y1,Kolor: Byte);
 Procedure FillBackGround (X,Y,X1,Y1,Tlo: Byte);

 Procedure PutAttr (X,Y,Kolor,Tlo: Byte);
 Procedure FillAttr (X,Y,X1,Y1,Kolor,Tlo: Byte);

 Function GetCharAndAttr (X,Y: Byte): Word;
 Function GetChar (X,Y: Byte): Char;
 Function GetAttr (X,Y: Byte): Byte;

Implementation


 Procedure Cls; Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AL,BYTE PTR ES:[0449H]
    INT         10H
 End;

 Function GetMode: Byte; Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AL,BYTE PTR ES:[0449H]
 End;

 Procedure GoToXY (X,Y: Byte); Assembler;
 Asm
    MOV         DH,BYTE PTR [Y]
    MOV         DL,BYTE PTR [X]
    XOR         BX,BX
    MOV         AX,0200H
    INT         10H
 End;

 Function WhereX: Byte; Assembler;
 Asm
    XOR         BX,BX
    MOV         AX,0300H
    INT         10H
    MOV         AL,DL
 End;

 Function WhereY: Byte; Assembler;
 Asm
    XOR         BX,BX
    MOV         AX,0300H
    INT         10H
    MOV         AL,DH
 End;

 Procedure HideKursor; Assembler;
 Asm
    MOV         CX,2000H
    MOV         AX,0100H
    INT         10H
 End;

 Procedure ShowKursor; Assembler;
 Asm
    MOV         CX,0708H
    MOV         AX,0100H
    INT         10H
 End;

 Procedure PutChar (X,Y: Byte;Znak: Char;Kolor,Tlo: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AH,BYTE PTR [TLO]
    SHL         AH,05H
    SHR         AH,01H
    ADD         AH,BYTE PTR [KOLOR]
    MOV         AL,BYTE PTR [ZNAK]
    CLD
    STOSW
 End;

 Procedure PutString (X,Y: Byte;Napis: String;Kolor,Tlo: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AH,BYTE PTR [TLO]
    SHL         AH,05H
    SHR         AH,01H
    ADD         AH,BYTE PTR [KOLOR]
    MOV         DX,DS
    LDS         SI,NAPIS
    CLD
    LODSB
    MOV         CL,AL
    JCXZ        @@DALEJ2
 @@PISZ:
    CLD
    LODSB
    STOSW
    LOOP        @@PISZ
 @@DALEJ2:
    MOV         DS,DX
 End;

 Procedure FillScreen (Znak: Char;Kolor,Tlo: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    XOR         DI,DI
    MOV         AH,BYTE PTR [TLO]
    SHL         AH,05H
    SHR         AH,01H
    ADD         AH,BYTE PTR [KOLOR]
    MOV         AL,BYTE PTR [ZNAK]
    MOV         CX,4000
    CLD
    REP         STOSW
 End;

 Procedure FillWindow (X,Y,X1,Y1: Byte;Znak: Char;Kolor,Tlo: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AH,BYTE PTR [TLO]
    SHL         AH,05H
    SHR         AH,01H
    ADD         AH,BYTE PTR [KOLOR]
    MOV         AL,BYTE PTR [ZNAK]
    MOV         CL,BYTE PTR [Y1]
 @@DALEJ2:
    MOV         DX,CX
    MOV         CL,BYTE PTR [X1]
    PUSH        DI
    CLD
    REP         STOSW
    POP         DI
    ADD         DI,160
    MOV         CX,DX
    LOOP        @@DALEJ2
 End;

 Procedure DrawWindow (X,Y,X1,Y1,Kolor,Tlo: Byte;Cien: Boolean;Var Linia); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AH,BYTE PTR [TLO]
    SHL         AH,05H
    SHR         AH,01H
    ADD         AH,BYTE PTR [KOLOR]
    MOV         DX,DS
    LDS         SI,LINIA
    PUSH        DI
    MOV         AL,BYTE PTR DS:[SI]
    CLD
    STOSW
    MOV         AL,BYTE PTR DS:[SI+01H]
    MOV         CL,BYTE PTR [X1]
    CLD
    REP         STOSW
    MOV         AL,BYTE PTR DS:[SI+02]
    CLD
    STOSW
    POP         DI
    MOV         CL,BYTE PTR [Y1]
    JCXZ        @@ZERO
 @@DALEJ2:
    ADD         DI,160
    PUSH        CX
    PUSH        DI
    MOV         AL,BYTE PTR DS:[SI+03]
    CLD
    STOSW
    MOV         AL,BYTE PTR DS:[SI+04H]
    MOV         CL,BYTE PTR [X1]
    CLD
    REP         STOSW
    MOV         AL,BYTE PTR DS:[SI+05]
    CLD
    STOSW
    POP         DI
    POP         CX
    LOOP        @@DALEJ2
 @@ZERO:
    ADD         DI,160
    MOV         AL,BYTE PTR DS:[SI+06]
    CLD
    STOSW
    MOV         AL,BYTE PTR DS:[SI+07H]
    MOV         CL,BYTE PTR [X1]
    CLD
    REP         STOSW
    MOV         AL,BYTE PTR DS:[SI+08]
    CLD
    STOSW
    MOV         DS,DX
    CMP         BYTE PTR [CIEN],TRUE
    JNE         @@DALEJ3
    MOV         CL,BYTE PTR [Y]
    INC         CL
    MOV         AX,0050H
    MUL         CL
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         CL,BYTE PTR [X1]
    ADD         CL,02H
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         CL,BYTE PTR [Y1]
    INC         CL
 @@DALEJ5:
    PUSH        CX
    PUSH        DI
    MOV         CL,02H
 @@DALEJ4:
    MOV         AX,WORD PTR ES:[DI]
    SHR         AH,07H
    SHL         AH,07H
    ADD         AH,08H
    CLD
    STOSW
    LOOP        @@DALEJ4
    POP         DI
    POP         CX
    ADD         DI,160
    LOOP        @@DALEJ5
    ADD         DI,02H
    MOV         CL,BYTE PTR [X1]
    ADD         CL,02H
 @@DALEJ6:
    MOV         AX,WORD PTR ES:[DI]
    SHR         AH,07H
    SHL         AH,07H
    ADD         AH,08H
    STD
    STOSW
    LOOP        @@DALEJ6
 @@DALEJ3:
 End;

 Procedure ButtonString (X,Y: Byte;Napis: String;Kolor,Tlo: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AH,BYTE PTR [TLO]
    SHL         AH,05H
    SHR         AH,01H
    ADD         AH,BYTE PTR [KOLOR]
    MOV         DX,DS
    LDS         SI,NAPIS
    CLD
    LODSB
    MOV         CL,AL
    JCXZ        @@DALEJ2
    PUSH        DI
 @@PISZ:
    CLD
    LODSB
    STOSW
    LOOP        @@PISZ
    MOV         AX,WORD PTR ES:[DI]
    SHR         AH,04H
    SHL         AH,04H
    MOV         AL,0DCH
    CLD
    STOSW
    POP         DI
    ADD         DI,162
    LDS         SI,NAPIS
    XOR         CH,CH
    MOV         CL,BYTE PTR DS:[SI]
    MOV         AL,0DFH
    CLD
    REP         STOSW
 @@DALEJ2:
    MOV         DS,DX
 End;

 Procedure LineDown (Napis: String;Kolor,Tlo,Spec: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         DI,0F02H
    PUSH        DS
    LDS         SI,NAPIS
    CLD
    LODSB
    XOR         AH,AH
    MOV         CX,AX
    JCXZ        @@KONIEC
    MOV         AH,BYTE PTR [TLO]
    SHL         AH,05H
    SHR         AH,01H
    ADD         AH,BYTE PTR [KOLOR]
    XOR         DL,DL
 @@PISZ:
    CLD
    LODSB
    CMP         AL,'~'
    JNE         @@SKOK
    SHR         AH,04H
    SHL         AH,04H
    CMP         DL,00H
    JE          @@ZMIENKOLOR
    XOR         DL,DL
    ADD         AH,BYTE PTR [KOLOR]
    LODSB
    DEC         CX
    JMP         @@SKOK
 @@ZMIENKOLOR:
    MOV         DL,01H
    ADD         AH,BYTE PTR [SPEC]
    LODSB
    DEC         CX
 @@SKOK:
    STOSW
    LOOP        @@PISZ
 @@KONIEC:
    POP         DS
 End;

 Function LoadSCR (Plik: String;P: Pointer;Ile: Word): Byte; Assembler;
 Asm
    JMP         @@DALEJ
 @@PLIK:        DD     00H,00H,00H,00H,00H,00H,00H,00H
                DD     00H,00H,00H,00H,00H,00H,00H,00H
 @@DALEJ:
    PUSH        DS
    LDS         SI,PLIK
    LEA         DI,@@PLIK
    PUSH        CS
    POP         ES
    CLD
    LODSB
    XOR         AH,AH
    MOV         CX,AX
    MOV         AL,01H
    JCXZ        @@KONIEC
    CLD
    REP         MOVSB
    XOR         AL,AL
    CLD
    STOSB
    LEA         DX,@@PLIK
    PUSH        CS
    POP         DS
    MOV         AX,3D02H
    INT         21H
    JC          @@KONIEC
    MOV         BX,AX
    XOR         CX,CX
    XOR         DX,DX
    MOV         AX,4200H
    INT         21H
    JC          @@ZAMKNIJ
    LDS         DX,P
    MOV         CX,WORD PTR [ILE]
    MOV         AX,3F00H
    INT         21H
 @@ZAMKNIJ:
    MOV         AX,3E00H
    INT         21H
    JC          @@KONIEC
    XOR         AX,AX
 @@KONIEC:
    POP         DS
 End;

 Function SaveSCR (Plik: String;P: Pointer;Ile: Word): Byte; Assembler;
 Asm
    JMP         @@DALEJ
 @@PLIK:        DD     00H,00H,00H,00H,00H,00H,00H,00H
                DD     00H,00H,00H,00H,00H,00H,00H,00H
 @@DALEJ:
    PUSH        DS
    LDS         SI,PLIK
    LEA         DI,@@PLIK
    PUSH        CS
    POP         ES
    CLD
    LODSB
    XOR         AH,AH
    MOV         CX,AX
    MOV         AL,01H
    JCXZ        @@KONIEC
    CLD
    REP         MOVSB
    XOR         AL,AL
    CLD
    STOSB
    LEA         DX,@@PLIK
    PUSH        CS
    POP         DS
    MOV         AX,3C00H
    INT         21H
    JC          @@KONIEC
    MOV         BX,AX
    XOR         CX,CX
    XOR         DX,DX
    MOV         AX,4200H
    INT         21H
    JC          @@ZAMKNIJ
    LDS         DX,P
    MOV         CX,WORD PTR [ILE]
    MOV         AX,4000H
    INT         21H
 @@ZAMKNIJ:
    MOV         AX,3E00H
    INT         21H
    JC          @@KONIEC
    XOR         AX,AX
 @@KONIEC:
    POP         DS
 End;

 Procedure GetScreen (P: Pointer); Assembler;
 Asm
    MOV         DX,DS
    XOR         AX,AX
    MOV         DS,AX
    MOV         AX,0B800H
    CMP         BYTE PTR DS:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         DS,AX
    XOR         SI,SI
    LES         DI,P
    MOV         CX,4000
    CLD
    REP         MOVSB
    MOV         DS,DX
 End;

 Procedure PutScreen (P: Pointer); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    XOR         DI,DI
    MOV         DX,DS
    LDS         SI,P
    MOV         CX,4000
    CLD
    REP         MOVSB
    MOV         DS,DX
 End;

 Procedure GetWindow (P: Pointer;X,Y,X1,Y1: Byte); Assembler;
 Asm
    JMP         @@DALEJ
 @@POZ:         DW     00H
 @@SZER:        DB     00H
 @@WYSOK:       DB     00H
 @@DALEJ:
    PUSH        DS
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         WORD PTR CS:[@@POZ],AX
    MOV         AL,BYTE PTR [X1]
    MOV         BYTE PTR CS:[@@SZER],AL
    MOV         AL,BYTE PTR [Y1]
    MOV         BYTE PTR CS:[@@WYSOK],AL
    LEA         SI,@@POZ
    PUSH        CS
    POP         DS
    LES         DI,P
    MOV         CX,0004H
    CLD
    REP         MOVSB
    XOR         AX,AX
    MOV         DS,AX
    MOV         AX,0B800H
    CMP         BYTE PTR DS:[0449H],03H
    JE          @@DALEJ2
    MOV         AX,0B000H
 @@DALEJ2:
    MOV         DS,AX
    MOV         SI,WORD PTR CS:[@@POZ]
    XOR         CH,CH
    MOV         CL,BYTE PTR [Y1]
    JCXZ        @@KONIEC
 @@PETLA:
    PUSH        CX
    XOR         CH,CH
    MOV         CL,BYTE PTR [X1]
    SHL         CL,01H
    CLD
    MOV         DX,SI
    REP         MOVSB
    MOV         SI,DX
    ADD         SI,160
    POP         CX
    LOOP        @@PETLA
 @@KONIEC:
    POP         DS
 End;

 Procedure PutWindow (P: Pointer); Assembler;
 Asm
    JMP         @@DALEJ
 @@POZ:         DW     00H
 @@SZER:        DB     00H
 @@WYSOK:       DB     00H
 @@DALEJ:
    PUSH        DS
    LDS         SI,P
    LEA         DI,@@POZ
    PUSH        CS
    POP         ES
    MOV         CX,0004H
    CLD
    REP         MOVSB
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ2
    MOV         AX,0B000H
 @@DALEJ2:
    MOV         ES,AX
    MOV         DI,WORD PTR CS:[@@POZ]
    XOR         CH,CH
    MOV         CL,BYTE PTR CS:[@@WYSOK]
    JCXZ        @@KONIEC
 @@PETLA:
    PUSH        CX
    XOR         CH,CH
    MOV         CL,BYTE PTR CS:[@@SZER]
    SHL         CL,01H
    CLD
    MOV         DX,DI
    REP         MOVSB
    MOV         DI,DX
    ADD         DI,160
    POP         CX
    LOOP        @@PETLA
 @@KONIEC:
    POP         DS
 End;

 Procedure xPutWindow (X,Y: Byte;P: Pointer); Assembler;
 Asm
    JMP         @@DALEJ
 @@POZ:         DW     00H
 @@SZER:        DB     00H
 @@WYSOK:       DB     00H
 @@DALEJ:
    PUSH        DS
    LDS         SI,P
    LEA         DI,@@POZ
    PUSH        CS
    POP         ES
    MOV         CX,0004H
    CLD
    REP         MOVSB
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ2
    MOV         AX,0B000H
 @@DALEJ2:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    XOR         CH,CH
    MOV         CL,BYTE PTR CS:[@@WYSOK]
    JCXZ        @@KONIEC
 @@PETLA:
    PUSH        CX
    XOR         CH,CH
    MOV         CL,BYTE PTR CS:[@@SZER]
    SHL         CL,01H
    CLD
    MOV         DX,DI
    REP         MOVSB
    MOV         DI,DX
    ADD         DI,160
    POP         CX
    LOOP        @@PETLA
 @@KONIEC:
    POP         DS
 End;

 Function GetFields (P: Pointer): Word; Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         DX,DS
    MOV         DS,AX
    XOR         SI,SI
    LES         DI,P
    ADD         DI,0002H
    XOR         BX,BX
    MOV         CX,2000
 @@PETLA:
    CLD
    LODSW
    CMP         AX,0000H
    JE          @@DALEJ2
    INC         BX
    PUSH        AX
    MOV         AX,SI
    SUB         AX,0002H
    CLD
    STOSW
    POP         AX
    CLD
    STOSW
 @@DALEJ2:
    LOOP        @@PETLA
    LES         DI,P
    MOV         AX,BX
    CLD
    STOSW
    MOV         DS,DX
 End;

 Procedure PutFields (P: Pointer); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         DX,DS
    LDS         SI,P
    CLD
    LODSW
    MOV         CX,AX
    JCXZ        @@KONIEC
 @@PETLA:
    CLD
    LODSW
    MOV         DI,AX
    CLD
    LODSW
    STOSW
    LOOP        @@PETLA
 @@KONIEC:
    MOV         DS,DX
 End;

 Procedure PutColor (X,Y,Kolor: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AX,WORD PTR ES:[DI]
    SHR         AH,04H
    SHL         AH,04H
    ADD         AH,BYTE PTR [KOLOR]
    CLD
    STOSW
 End;

 Procedure PutBackGround (X,Y,Tlo: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AX,WORD PTR ES:[DI]
    ROR         AH,04H
    SHR         AH,03H
    SHL         AH,03H
    ADD         AH,BYTE PTR [TLO]
    ROL         AH,04H
    CLD
    STOSW
 End;

 Procedure FillColor (X,Y,X1,Y1,Kolor: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         CL,BYTE PTR [Y1]
    JCXZ        @@KONIEC
 @@PETLA2:
    MOV         DX,CX
    MOV         BX,DI
    MOV         CL,BYTE PTR [X1]
 @@PETLA1:
    MOV         AX,WORD PTR ES:[DI]
    SHR         AH,04H
    SHL         AH,04H
    ADD         AH,BYTE PTR [KOLOR]
    CLD
    STOSW
    LOOP        @@PETLA1
    MOV         DI,BX
    ADD         DI,160
    MOV         CX,DX
    LOOP        @@PETLA2
 @@KONIEC:
 End;

 Procedure FillBackGround (X,Y,X1,Y1,Tlo: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         CL,BYTE PTR [Y1]
    JCXZ        @@KONIEC
 @@PETLA2:
    MOV         DX,CX
    MOV         BX,DI
    MOV         CL,BYTE PTR [X1]
 @@PETLA1:
    MOV         AX,WORD PTR ES:[DI]
    ROR         AH,04H
    SHR         AH,03H
    SHL         AH,03H
    ADD         AH,BYTE PTR [TLO]
    ROL         AH,04H
    CLD
    STOSW
    LOOP        @@PETLA1
    MOV         DI,BX
    ADD         DI,160
    MOV         CX,DX
    LOOP        @@PETLA2
 @@KONIEC:
 End;

 Procedure PutAttr (X,Y,Kolor,Tlo: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AX,WORD PTR ES:[DI]
    MOV         AH,BYTE PTR [TLO]
    SHL         AH,05H
    SHR         AH,01H
    ADD         AH,BYTE PTR [KOLOR]
    CLD
    STOSW
 End;

 Procedure FillAttr (X,Y,X1,Y1,Kolor,Tlo: Byte); Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         CL,BYTE PTR [Y1]
    JCXZ        @@KONIEC
 @@PETLA2:
    MOV         DX,CX
    MOV         BX,DI
    MOV         CL,BYTE PTR [X1]
 @@PETLA1:
    MOV         AX,WORD PTR ES:[DI]
    MOV         AH,BYTE PTR [TLO]
    SHL         AH,05H
    SHR         AH,01H
    ADD         AH,BYTE PTR [KOLOR]
    CLD
    STOSW
    LOOP        @@PETLA1
    MOV         DI,BX
    ADD         DI,160
    MOV         CX,DX
    LOOP        @@PETLA2
 @@KONIEC:
 End;

 Function GetCharAndAttr (X,Y:Byte): Word; Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AX,WORD PTR ES:[DI]
 End;

 Function GetChar (X,Y: Byte): Char; Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AL,BYTE PTR ES:[DI]
 End;

 Function GetAttr (X,Y: Byte): Byte; Assembler;
 Asm
    XOR         AX,AX
    MOV         ES,AX
    MOV         AX,0B800H
    CMP         BYTE PTR ES:[0449H],03H
    JE          @@DALEJ
    MOV         AX,0B000H
 @@DALEJ:
    MOV         ES,AX
    MOV         AX,0050H
    MUL         BYTE PTR [Y]
    XOR         CH,CH
    MOV         CL,BYTE PTR [X]
    ADD         AX,CX
    SHL         AX,01H
    MOV         DI,AX
    MOV         AL,BYTE PTR ES:[DI+02H]
 End;


Begin
End.