{$I-}
{$G+}
Unit USETOOLS; (* Piotr Pawlus *)


Interface

 Const
      Enter             =       #13;
      Esc               =       #27;
      Tab               =       #9;
      BackSpace         =       #8;
      Space             =       #32;
      Up                =       #72;
      Down              =       #80;
      Right             =       #77;
      Left              =       #75;
      _Delete           =       #83;
      Home              =       #71;
      _End              =       #79;
      PgUp              =       #73;
      PgDn              =       #81;
      F1                =       #59;
      F2                =       #60;
      F3                =       #61;
      F4                =       #62;
      F5                =       #63;
      F6                =       #64;
      F7                =       #65;
      F8                =       #66;
      F9                =       #67;
      F10               =       #68;
      CtrlHome          =       #119;
      CtrlEnd           =       #117;
      CtrlPgUp          =       #132;
      CtrlPgDn          =       #118;
      CtrlUp            =       #141;
      CtrlDown          =       #145;
      CtrlRight         =       #116;
      CtrlLeft          =       #115;

 Var
    SpecKey     :       Boolean;


 Function ReadKey: Char;
 Function KeyPressed: Boolean;

 Procedure MemRead (Var Zrodlo;Var Cel;_OffS,_OffC: Word;Ile: Word);
 Function FillString (Znak: Char;Ile: Byte): String;
 Function SearchChar (Napis: String;Znak: Char;_Off: Byte): Byte;

 Procedure Pause (Czas: Word);
 Procedure GetIntVector (Numer: Byte;Var P: Pointer);
 Procedure SetIntVector (Numer: Byte;P: Pointer);

 Procedure ClearBuffor (Var Dane;Ile: Word);

Implementation


 Function ReadKey: Char; Assembler;
 Asm
    MOV         BYTE PTR DS:[SPECKEY],00H
    MOV         AX,0800H
    INT         21H
    CMP         AL,00H
    JNE         @@DALEJ
    MOV         AX,0800H
    INT         21H
    MOV         BYTE PTR DS:[SPECKEY],01H
 @@DALEJ:
 End;

 Function KeyPressed: Boolean; Assembler;
 Asm
    MOV         AX,0100H
    INT         16H
    MOV         AL,00
    JE          @@DALEJ
    MOV         AL,01H
 @@DALEJ:
 End;

 Procedure MemRead (Var Zrodlo;Var Cel;_OffS,_OffC: Word;Ile: Word); Assembler;
 Asm
    MOV         DX,DS
    MOV         CX,WORD PTR [ILE]
    JCXZ        @@KONIEC
    LDS         SI,ZRODLO
    ADD         SI,WORD PTR [_OFFS]
    LES         DI,CEL
    ADD         DI,WORD PTR [_OFFC]
    CLD
    REP         MOVSB
 @@KONIEC:
    MOV         DS,DX
 End;

 Function FillString (Znak: Char;Ile: Byte): String; Assembler;
 Asm
    LES        DI,@RESULT
    MOV        AL,BYTE PTR [ILE]
    CLD
    STOSB
    XOR        AH,AH
    MOV        CX,AX
    JCXZ       @@KONIEC
    CLD
    MOV        AL,BYTE PTR [ZNAK]
    REP        STOSB
 @@KONIEC:
 End;

 Function SearchChar (Napis: String;Znak: Char;_Off: Byte): Byte; Assembler;
 Asm
    MOV        DX,DS
    LDS        SI,NAPIS
    LODSB
    XOR        AH,AH
    MOV        CX,AX
    JCXZ       @@KONIEC
    MOV        AL,BYTE PTR [_OFF]
    SUB        CX,AX
    ADD        SI,AX
 @@PETLA:
    INC        AH
    LODSB
    CMP        AL,BYTE PTR [ZNAK]
    JE         @@KONIEC
    LOOP       @@PETLA
 @@KONIEC:
    MOV        AL,AH
    MOV        DS,DX
 End;


 Procedure Pause (Czas: Word); Assembler;
 Asm
    MOV        CX,WORD PTR [CZAS]
    JCXZ       @@END
 @@1:
    MOV        DX,CX
 @@2:
    DEC        DX
    JNZ        @@2
    DEC        CX
    JNZ        @@1
 @@END:
 End;


 Procedure GetIntVector (Numer: Byte;Var P: Pointer); Assembler;
 Asm
    MOV        AH,35H
    MOV        AL,BYTE PTR [NUMER]
    INT        21H
    MOV        DX,DS
    MOV        AX,ES
    MOV        DS,AX
    MOV        SI,BX
    LES        DI,P
    LODSW
    STOSW
    LODSW
    STOSW
    MOV        DS,DX
 End;


 Procedure SetIntVector (Numer: Byte;P: Pointer); Assembler;
 Asm
    MOV        BX,DS
    LDS        DX,P
    MOV        AH,25H
    MOV        AL,BYTE PTR [NUMER]
    INT        21H
    MOV        DS,BX
 End;


 Procedure ClearBuffor (Var Dane;Ile: Word); Assembler;
 Asm
    LES         DI,DANE
    MOV         CX,WORD PTR [ILE]
    XOR         AL,AL
    REP         STOSB
 End;


Begin
End.
